from pessoa import Pessoa
from filme import Filme
from temporada import Temporada
from livro import Livro
from midia import Midia
from emprestimo import Emprestimo
import datetime
import sys

generos = dict()
pessoas = dict()
midias = dict()
series = dict()
emprestimos = list()
tipos = {"F":"filme","L":"livro","S":"temporada"}

size = len(sys.argv)
indexG = int(sys.argv.index("-g")) + 1
indexP = int(sys.argv.index("-p")) + 1
indexM = int(sys.argv.index("-m")) + 1
indexE = int(sys.argv.index("-e")) + 1


arquivoGeneros = open(sys.argv[indexG], "r")
vetG = arquivoGeneros.read().split('\n')
for i in vetG:
	k = i.split(';')
	sigla = k[0]
	nome = k[1]
	generos[sigla] = nome
arquivoGeneros.close()


arquivoPessoas = open(sys.argv[indexP], "r")
vetP = arquivoPessoas.read().split('\n')
for i in vetP:
	k = i.split(';')
	codigo = int(k[0])
	nome = k[1]
	pessoas[codigo] = Pessoa(codigo, nome)
midiasPessoa = dict()
tipos = {"F":"filme","L":"livro","S":"temporada"}
arquivoPessoas.close()


arquivoMidias = open(sys.argv[indexM], "r")
vetM = arquivoMidias.read().split('\n')
for i in vetM:
	k = i.split(';')
	codigo = int(k[0])
	nome = k[1]
	tipo = tipos[k[2]]
	a_utores = list()
	if k[4] != '':
		codArtistas = k[4].split(",")
		for i in range(len(codArtistas)):
			pessoa = pessoas[int(codArtistas[i])]
			a_utores.append(pessoa)
	tamanho = int(k[5])
	genero = generos[k[6]]
	possui = k[9] == "X"
	consumiu = k[10] == "X"
	deseja = k[11] == "X"
	preco = float(k[12])
	if(k[2] == 'F'):
		diretor = pessoas[int(k[3])]
		atores = a_utores
		duracao = tamanho
		midias[codigo] = Filme(codigo, nome, tipo, genero, possui, consumiu, deseja, preco, diretor, atores, duracao)
		pessoas[diretor.get_codigo()].add_midia(midias[codigo])
	elif(k[2] == 'L'):
		autores = a_utores
		nPaginas = tamanho
		midias[codigo] = Livro(codigo, nome, tipo, genero, possui, consumiu, deseja, preco, autores, nPaginas)
	elif(k[2] == 'S'):
		atores = a_utores
		duracao = tamanho
		serie = k[7]
		temporada = int(k[8])
		midias[codigo] = Temporada(codigo, nome, tipo, genero, possui, consumiu, deseja, preco, atores, duracao, serie, temporada)
		if(serie in series):
			series[serie].append(temporada)
		else:
			series[serie] = [temporada]
	else :
		print('Tipo de midia deve ser "F","L" ou "S"')
	for i in a_utores:
		pessoas[i.get_codigo()].add_midia(midias[codigo])
arquivoMidias.close()


arquivoEmprestimos = open(sys.argv[indexE], "r")
vetE = arquivoEmprestimos.read().split('\n')
for i in vetE:
	k = i.split(';')
	midia = midias[int(k[0])]
	tomador = k[1]
	emprestimo = datetime.datetime.strptime(k[2], '%d/%m/%Y').date()
	devolucao = datetime.datetime.strptime(k[3], '%d/%m/%Y').date()
	a = Emprestimo(midia, tomador, emprestimo, devolucao)
	emprestimos.append(Emprestimo(midia, tomador, emprestimo, devolucao))
arquivoEmprestimos.close()


arquivoPessoas = open("pessoas.csv","w")
listaArtistasComTrabalhos = list()
for i in pessoas.values():
	if len(i.get_midias()) >0:
		listaArtistasComTrabalhos.append(i)
listaArtistasComTrabalhos.sort(key = lambda pessoa: pessoa.get_nome())
arquivoPessoas.write(listaArtistasComTrabalhos[0].toMidiasPessoa())
for i in range(1,len(listaArtistasComTrabalhos)):
	arquivoPessoas.write("\n" + listaArtistasComTrabalhos[i].toMidiasPessoa())
arquivoPessoas.close()


arquivoWishlist = open("wishlist.csv","w")
listaWishlist = list()
for i in midias.values():
	if i.get_deseja() and not i.get_possui() and not i.get_consumiu():
		listaWishlist.append(i)
listaWishlist.sort(key = lambda midia: (midia.get_tipo(),-midia.get_preco(),midia.get_nome()))
arquivoWishlist.write(listaWishlist[0].toWishlist())
for i in range(1,len(listaWishlist)):
	arquivoWishlist.write("\n" + listaWishlist[i].toWishlist())
arquivoWishlist.close()